// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventPipe.py

******************************************************************/


#include <common.h>
#include <gcenv.h>

#include <eventtrace_context.h>
#include <gcheaputilities.h>

#include <eventpipe/ep.h>
#include <eventpipe/ep-provider.h>
#include <eventpipe/ep-config.h>
#include <eventpipe/ep-event.h>
#include <eventpipe/ep-event-instance.h>
#include <eventpipe/ep-session.h>
#include <eventpipe/ep-session-provider.h>
#include <eventpipe/ep-metadata-generator.h>
#include <eventpipe/ep-event-payload.h>
#include <eventpipe/ep-buffer-manager.h>


#ifndef W
#define W(str) L##str
#endif
#ifndef SL
#define SL(str) str
#endif
#ifndef ERROR_SUCCESS
#define ERROR_SUCCESS 0L
#endif
#ifndef ERROR_WRITE_FAULT
#define ERROR_WRITE_FAULT 29L
#endif


bool ResizeBuffer(BYTE *&buffer, size_t& size, size_t currLen, size_t newSize, bool &fixedBuffer);
bool WriteToBuffer(const WCHAR* str, BYTE *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);
bool WriteToBuffer(const BYTE *src, size_t len, BYTE *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);

EventPipeProvider * create_provider(const WCHAR*, EventPipeCallback, void* pCallbackContext = nullptr);

template <typename T>
bool WriteToBuffer(const T &value, BYTE *&buffer, size_t& offset, size_t& size, bool &fixedBuffer)
{
    if (sizeof(T) + offset > size)
    {
        if (!ResizeBuffer(buffer, size, offset, size + sizeof(T), fixedBuffer))
            return false;
    }

    memcpy(buffer + offset, (char *)&value, sizeof(T));
    offset += sizeof(T);
    return true;
}


const WCHAR* DotNETRuntimeName = W("Microsoft-Windows-DotNETRuntime");
EventPipeProvider *EventPipeProviderDotNETRuntime = nullptr;
EventPipeEvent *EventPipeEventGCStart_V2 = nullptr;
EventPipeEvent *EventPipeEventGCEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventGCRestartEEEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventGCHeapStats_V2 = nullptr;
EventPipeEvent *EventPipeEventGCCreateSegment_V1 = nullptr;
EventPipeEvent *EventPipeEventGCFreeSegment_V1 = nullptr;
EventPipeEvent *EventPipeEventGCRestartEEBegin_V1 = nullptr;
EventPipeEvent *EventPipeEventGCSuspendEEEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventGCSuspendEEBegin_V1 = nullptr;
EventPipeEvent *EventPipeEventGCAllocationTick_V4 = nullptr;
EventPipeEvent *EventPipeEventGCCreateConcurrentThread_V1 = nullptr;
EventPipeEvent *EventPipeEventGCTerminateConcurrentThread_V1 = nullptr;
EventPipeEvent *EventPipeEventGCFinalizersEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventGCFinalizersBegin_V1 = nullptr;
EventPipeEvent *EventPipeEventBulkType = nullptr;
EventPipeEvent *EventPipeEventGCBulkRootEdge = nullptr;
EventPipeEvent *EventPipeEventGCBulkRootConditionalWeakTableElementEdge = nullptr;
EventPipeEvent *EventPipeEventGCBulkNode = nullptr;
EventPipeEvent *EventPipeEventGCBulkEdge = nullptr;
EventPipeEvent *EventPipeEventGCSampledObjectAllocationHigh = nullptr;
EventPipeEvent *EventPipeEventGCBulkSurvivingObjectRanges = nullptr;
EventPipeEvent *EventPipeEventGCBulkMovedObjectRanges = nullptr;
EventPipeEvent *EventPipeEventGCGenerationRange = nullptr;
EventPipeEvent *EventPipeEventGCMarkStackRoots = nullptr;
EventPipeEvent *EventPipeEventGCMarkFinalizeQueueRoots = nullptr;
EventPipeEvent *EventPipeEventGCMarkHandles = nullptr;
EventPipeEvent *EventPipeEventGCMarkOlderGenerationRoots = nullptr;
EventPipeEvent *EventPipeEventFinalizeObject = nullptr;
EventPipeEvent *EventPipeEventSetGCHandle = nullptr;
EventPipeEvent *EventPipeEventDestroyGCHandle = nullptr;
EventPipeEvent *EventPipeEventGCSampledObjectAllocationLow = nullptr;
EventPipeEvent *EventPipeEventPinObjectAtGCTime = nullptr;
EventPipeEvent *EventPipeEventGCTriggered = nullptr;
EventPipeEvent *EventPipeEventGCBulkRootCCW = nullptr;
EventPipeEvent *EventPipeEventGCBulkRCW = nullptr;
EventPipeEvent *EventPipeEventGCBulkRootStaticVar = nullptr;
EventPipeEvent *EventPipeEventGCDynamicEvent = nullptr;
EventPipeEvent *EventPipeEventThreadpoolSuspensionSuspendThread = nullptr;
EventPipeEvent *EventPipeEventThreadpoolSuspensionResumeThread = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadStart = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadStop = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadRetirementStart = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadRetirementStop = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadAdjustmentSample = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadAdjustmentAdjustment = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadAdjustmentStats = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadWait = nullptr;
EventPipeEvent *EventPipeEventYieldProcessorMeasurement = nullptr;
EventPipeEvent *EventPipeEventThreadPoolMinMaxThreads = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkingThreadCount = nullptr;
EventPipeEvent *EventPipeEventThreadPoolEnqueue = nullptr;
EventPipeEvent *EventPipeEventThreadPoolDequeue = nullptr;
EventPipeEvent *EventPipeEventThreadPoolIOEnqueue = nullptr;
EventPipeEvent *EventPipeEventThreadPoolIODequeue = nullptr;
EventPipeEvent *EventPipeEventThreadPoolIOPack = nullptr;
EventPipeEvent *EventPipeEventThreadCreating = nullptr;
EventPipeEvent *EventPipeEventThreadRunning = nullptr;
EventPipeEvent *EventPipeEventExceptionThrown_V1 = nullptr;
EventPipeEvent *EventPipeEventExceptionCatchStart = nullptr;
EventPipeEvent *EventPipeEventExceptionCatchStop = nullptr;
EventPipeEvent *EventPipeEventExceptionFinallyStart = nullptr;
EventPipeEvent *EventPipeEventExceptionFinallyStop = nullptr;
EventPipeEvent *EventPipeEventExceptionFilterStart = nullptr;
EventPipeEvent *EventPipeEventExceptionFilterStop = nullptr;
EventPipeEvent *EventPipeEventExceptionThrownStop = nullptr;
EventPipeEvent *EventPipeEventContention = nullptr;
EventPipeEvent *EventPipeEventContentionStart_V2 = nullptr;
EventPipeEvent *EventPipeEventContentionStop_V1 = nullptr;
EventPipeEvent *EventPipeEventContentionLockCreated = nullptr;
EventPipeEvent *EventPipeEventThreadCreated = nullptr;
EventPipeEvent *EventPipeEventModuleLoad_V2 = nullptr;
EventPipeEvent *EventPipeEventIncreaseMemoryPressure = nullptr;
EventPipeEvent *EventPipeEventDecreaseMemoryPressure = nullptr;
EventPipeEvent *EventPipeEventGCMarkWithType = nullptr;
EventPipeEvent *EventPipeEventGCJoin_V2 = nullptr;
EventPipeEvent *EventPipeEventGCPerHeapHistory_V3 = nullptr;
EventPipeEvent *EventPipeEventGCGlobalHeapHistory_V4 = nullptr;
EventPipeEvent *EventPipeEventGenAwareBegin = nullptr;
EventPipeEvent *EventPipeEventGenAwareEnd = nullptr;
EventPipeEvent *EventPipeEventGCLOHCompact = nullptr;
EventPipeEvent *EventPipeEventGCFitBucketInfo = nullptr;
EventPipeEvent *EventPipeEventExecutionCheckpoint = nullptr;
EventPipeEvent *EventPipeEventWaitHandleWaitStart = nullptr;
EventPipeEvent *EventPipeEventWaitHandleWaitStop = nullptr;

BOOL EventPipeEventEnabledGCStart_V2(void)
{
    return ep_event_is_enabled(EventPipeEventGCStart_V2);
}

ULONG EventPipeWriteEventGCStart_V2(
    const unsigned int Count,
    const unsigned int Depth,
    const unsigned int Reason,
    const unsigned int Type,
    const unsigned short ClrInstanceID,
    const uint64_t ClientSequenceNumber,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCStart_V2())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Depth, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClientSequenceNumber, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCStart_V2, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCEnd_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCEnd_V1);
}

ULONG EventPipeWriteEventGCEnd_V1(
    const unsigned int Count,
    const unsigned int Depth,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCEnd_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Depth, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCEnd_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCRestartEEEnd_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCRestartEEEnd_V1);
}

ULONG EventPipeWriteEventGCRestartEEEnd_V1(
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCRestartEEEnd_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCRestartEEEnd_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCHeapStats_V2(void)
{
    return ep_event_is_enabled(EventPipeEventGCHeapStats_V2);
}

ULONG EventPipeWriteEventGCHeapStats_V2(
    const uint64_t GenerationSize0,
    const uint64_t TotalPromotedSize0,
    const uint64_t GenerationSize1,
    const uint64_t TotalPromotedSize1,
    const uint64_t GenerationSize2,
    const uint64_t TotalPromotedSize2,
    const uint64_t GenerationSize3,
    const uint64_t TotalPromotedSize3,
    const uint64_t FinalizationPromotedSize,
    const uint64_t FinalizationPromotedCount,
    const unsigned int PinnedObjectCount,
    const unsigned int SinkBlockCount,
    const unsigned int GCHandleCount,
    const unsigned short ClrInstanceID,
    const uint64_t GenerationSize4,
    const uint64_t TotalPromotedSize4,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCHeapStats_V2())
        return ERROR_SUCCESS;

    size_t size = 110;
    BYTE stackBuffer[110];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(GenerationSize0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize3, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize3, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FinalizationPromotedSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FinalizationPromotedCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PinnedObjectCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SinkBlockCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GCHandleCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize4, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize4, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCHeapStats_V2, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCCreateSegment_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCCreateSegment_V1);
}

ULONG EventPipeWriteEventGCCreateSegment_V1(
    const uint64_t Address,
    const uint64_t Size,
    const unsigned int Type,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCCreateSegment_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Size, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCCreateSegment_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFreeSegment_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCFreeSegment_V1);
}

ULONG EventPipeWriteEventGCFreeSegment_V1(
    const uint64_t Address,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFreeSegment_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCFreeSegment_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCRestartEEBegin_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCRestartEEBegin_V1);
}

ULONG EventPipeWriteEventGCRestartEEBegin_V1(
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCRestartEEBegin_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCRestartEEBegin_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSuspendEEEnd_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCSuspendEEEnd_V1);
}

ULONG EventPipeWriteEventGCSuspendEEEnd_V1(
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSuspendEEEnd_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCSuspendEEEnd_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSuspendEEBegin_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCSuspendEEBegin_V1);
}

ULONG EventPipeWriteEventGCSuspendEEBegin_V1(
    const unsigned int Reason,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSuspendEEBegin_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCSuspendEEBegin_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCAllocationTick_V4(void)
{
    return ep_event_is_enabled(EventPipeEventGCAllocationTick_V4);
}

ULONG EventPipeWriteEventGCAllocationTick_V4(
    const unsigned int AllocationAmount,
    const unsigned int AllocationKind,
    const unsigned short ClrInstanceID,
    const uint64_t AllocationAmount64,
    const void* TypeID,
    const WCHAR* TypeName,
    const unsigned int HeapIndex,
    const void* Address,
    const uint64_t ObjectSize,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCAllocationTick_V4())
        return ERROR_SUCCESS;

    size_t size = 110;
    BYTE stackBuffer[110];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!TypeName) { TypeName = W("NULL"); }
    success &= WriteToBuffer(AllocationAmount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AllocationKind, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AllocationAmount64, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(HeapIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectSize, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCAllocationTick_V4, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCCreateConcurrentThread_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCCreateConcurrentThread_V1);
}

ULONG EventPipeWriteEventGCCreateConcurrentThread_V1(
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCCreateConcurrentThread_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCCreateConcurrentThread_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCTerminateConcurrentThread_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCTerminateConcurrentThread_V1);
}

ULONG EventPipeWriteEventGCTerminateConcurrentThread_V1(
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCTerminateConcurrentThread_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCTerminateConcurrentThread_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFinalizersEnd_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCFinalizersEnd_V1);
}

ULONG EventPipeWriteEventGCFinalizersEnd_V1(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFinalizersEnd_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCFinalizersEnd_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFinalizersBegin_V1(void)
{
    return ep_event_is_enabled(EventPipeEventGCFinalizersBegin_V1);
}

ULONG EventPipeWriteEventGCFinalizersBegin_V1(
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFinalizersBegin_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCFinalizersBegin_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBulkType(void)
{
    return ep_event_is_enabled(EventPipeEventBulkType);
}

ULONG EventPipeWriteEventBulkType(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledBulkType())
        return ERROR_SUCCESS;

    size_t size = 38;
    BYTE stackBuffer[38];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)(Values_ElementSize), buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventBulkType, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkRootEdge(void)
{
    return ep_event_is_enabled(EventPipeEventGCBulkRootEdge);
}

ULONG EventPipeWriteEventGCBulkRootEdge(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkRootEdge())
        return ERROR_SUCCESS;

    size_t size = 42;
    BYTE stackBuffer[42];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCBulkRootEdge, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkRootConditionalWeakTableElementEdge(void)
{
    return ep_event_is_enabled(EventPipeEventGCBulkRootConditionalWeakTableElementEdge);
}

ULONG EventPipeWriteEventGCBulkRootConditionalWeakTableElementEdge(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkRootConditionalWeakTableElementEdge())
        return ERROR_SUCCESS;

    size_t size = 42;
    BYTE stackBuffer[42];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCBulkRootConditionalWeakTableElementEdge, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkNode(void)
{
    return ep_event_is_enabled(EventPipeEventGCBulkNode);
}

ULONG EventPipeWriteEventGCBulkNode(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkNode())
        return ERROR_SUCCESS;

    size_t size = 42;
    BYTE stackBuffer[42];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCBulkNode, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkEdge(void)
{
    return ep_event_is_enabled(EventPipeEventGCBulkEdge);
}

ULONG EventPipeWriteEventGCBulkEdge(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkEdge())
        return ERROR_SUCCESS;

    size_t size = 42;
    BYTE stackBuffer[42];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCBulkEdge, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSampledObjectAllocationHigh(void)
{
    return ep_event_is_enabled(EventPipeEventGCSampledObjectAllocationHigh);
}

ULONG EventPipeWriteEventGCSampledObjectAllocationHigh(
    const void* Address,
    const void* TypeID,
    const unsigned int ObjectCountForTypeSample,
    const uint64_t TotalSizeForTypeSample,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSampledObjectAllocationHigh())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectCountForTypeSample, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalSizeForTypeSample, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCSampledObjectAllocationHigh, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkSurvivingObjectRanges(void)
{
    return ep_event_is_enabled(EventPipeEventGCBulkSurvivingObjectRanges);
}

ULONG EventPipeWriteEventGCBulkSurvivingObjectRanges(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkSurvivingObjectRanges())
        return ERROR_SUCCESS;

    size_t size = 42;
    BYTE stackBuffer[42];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCBulkSurvivingObjectRanges, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkMovedObjectRanges(void)
{
    return ep_event_is_enabled(EventPipeEventGCBulkMovedObjectRanges);
}

ULONG EventPipeWriteEventGCBulkMovedObjectRanges(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkMovedObjectRanges())
        return ERROR_SUCCESS;

    size_t size = 42;
    BYTE stackBuffer[42];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCBulkMovedObjectRanges, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCGenerationRange(void)
{
    return ep_event_is_enabled(EventPipeEventGCGenerationRange);
}

ULONG EventPipeWriteEventGCGenerationRange(
    const unsigned char Generation,
    const void* RangeStart,
    const uint64_t RangeUsedLength,
    const uint64_t RangeReservedLength,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCGenerationRange())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Generation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeStart, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeUsedLength, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeReservedLength, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCGenerationRange, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCMarkStackRoots(void)
{
    return ep_event_is_enabled(EventPipeEventGCMarkStackRoots);
}

ULONG EventPipeWriteEventGCMarkStackRoots(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCMarkStackRoots())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCMarkStackRoots, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCMarkFinalizeQueueRoots(void)
{
    return ep_event_is_enabled(EventPipeEventGCMarkFinalizeQueueRoots);
}

ULONG EventPipeWriteEventGCMarkFinalizeQueueRoots(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCMarkFinalizeQueueRoots())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCMarkFinalizeQueueRoots, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCMarkHandles(void)
{
    return ep_event_is_enabled(EventPipeEventGCMarkHandles);
}

ULONG EventPipeWriteEventGCMarkHandles(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCMarkHandles())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCMarkHandles, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCMarkOlderGenerationRoots(void)
{
    return ep_event_is_enabled(EventPipeEventGCMarkOlderGenerationRoots);
}

ULONG EventPipeWriteEventGCMarkOlderGenerationRoots(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCMarkOlderGenerationRoots())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCMarkOlderGenerationRoots, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFinalizeObject(void)
{
    return ep_event_is_enabled(EventPipeEventFinalizeObject);
}

ULONG EventPipeWriteEventFinalizeObject(
    const void* TypeID,
    const void* ObjectID,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledFinalizeObject())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventFinalizeObject, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledSetGCHandle(void)
{
    return ep_event_is_enabled(EventPipeEventSetGCHandle);
}

ULONG EventPipeWriteEventSetGCHandle(
    const void* HandleID,
    const void* ObjectID,
    const unsigned int Kind,
    const unsigned int Generation,
    const uint64_t AppDomainID,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledSetGCHandle())
        return ERROR_SUCCESS;

    size_t size = 34;
    BYTE stackBuffer[34];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(HandleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Kind, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Generation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventSetGCHandle, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDestroyGCHandle(void)
{
    return ep_event_is_enabled(EventPipeEventDestroyGCHandle);
}

ULONG EventPipeWriteEventDestroyGCHandle(
    const void* HandleID,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledDestroyGCHandle())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(HandleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventDestroyGCHandle, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSampledObjectAllocationLow(void)
{
    return ep_event_is_enabled(EventPipeEventGCSampledObjectAllocationLow);
}

ULONG EventPipeWriteEventGCSampledObjectAllocationLow(
    const void* Address,
    const void* TypeID,
    const unsigned int ObjectCountForTypeSample,
    const uint64_t TotalSizeForTypeSample,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSampledObjectAllocationLow())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectCountForTypeSample, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalSizeForTypeSample, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCSampledObjectAllocationLow, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPinObjectAtGCTime(void)
{
    return ep_event_is_enabled(EventPipeEventPinObjectAtGCTime);
}

ULONG EventPipeWriteEventPinObjectAtGCTime(
    const void* HandleID,
    const void* ObjectID,
    const uint64_t ObjectSize,
    const WCHAR* TypeName,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledPinObjectAtGCTime())
        return ERROR_SUCCESS;

    size_t size = 90;
    BYTE stackBuffer[90];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!TypeName) { TypeName = W("NULL"); }
    success &= WriteToBuffer(HandleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventPinObjectAtGCTime, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCTriggered(void)
{
    return ep_event_is_enabled(EventPipeEventGCTriggered);
}

ULONG EventPipeWriteEventGCTriggered(
    const unsigned int Reason,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCTriggered())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCTriggered, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkRootCCW(void)
{
    return ep_event_is_enabled(EventPipeEventGCBulkRootCCW);
}

ULONG EventPipeWriteEventGCBulkRootCCW(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkRootCCW())
        return ERROR_SUCCESS;

    size_t size = 38;
    BYTE stackBuffer[38];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)(Values_ElementSize), buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCBulkRootCCW, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkRCW(void)
{
    return ep_event_is_enabled(EventPipeEventGCBulkRCW);
}

ULONG EventPipeWriteEventGCBulkRCW(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkRCW())
        return ERROR_SUCCESS;

    size_t size = 38;
    BYTE stackBuffer[38];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)(Values_ElementSize), buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCBulkRCW, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkRootStaticVar(void)
{
    return ep_event_is_enabled(EventPipeEventGCBulkRootStaticVar);
}

ULONG EventPipeWriteEventGCBulkRootStaticVar(
    const unsigned int Count,
    const uint64_t AppDomainID,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkRootStaticVar())
        return ERROR_SUCCESS;

    size_t size = 46;
    BYTE stackBuffer[46];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)(Values_ElementSize), buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCBulkRootStaticVar, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCDynamicEvent(void)
{
    return ep_event_is_enabled(EventPipeEventGCDynamicEvent);
}

ULONG EventPipeWriteEventGCDynamicEvent(
    const WCHAR* Name,
    const unsigned int DataSize,
    const BYTE* Data,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCDynamicEvent())
        return ERROR_SUCCESS;

    size_t size = 71;
    BYTE stackBuffer[71];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!Name) { Name = W("NULL"); }
    success &= WriteToBuffer(Name, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DataSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Data, sizeof(const uint8_t) * (int)DataSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCDynamicEvent, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadpoolSuspensionSuspendThread(void)
{
    return ep_event_is_enabled(EventPipeEventThreadpoolSuspensionSuspendThread);
}

ULONG EventPipeWriteEventThreadpoolSuspensionSuspendThread(
    const unsigned int ClrThreadID,
    const unsigned int CpuUtilization,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadpoolSuspensionSuspendThread())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CpuUtilization, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadpoolSuspensionSuspendThread, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadpoolSuspensionResumeThread(void)
{
    return ep_event_is_enabled(EventPipeEventThreadpoolSuspensionResumeThread);
}

ULONG EventPipeWriteEventThreadpoolSuspensionResumeThread(
    const unsigned int ClrThreadID,
    const unsigned int CpuUtilization,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadpoolSuspensionResumeThread())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CpuUtilization, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadpoolSuspensionResumeThread, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadStart(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolWorkerThreadStart);
}

ULONG EventPipeWriteEventThreadPoolWorkerThreadStart(
    const unsigned int ActiveWorkerThreadCount,
    const unsigned int RetiredWorkerThreadCount,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadStart())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ActiveWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolWorkerThreadStart, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadStop(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolWorkerThreadStop);
}

ULONG EventPipeWriteEventThreadPoolWorkerThreadStop(
    const unsigned int ActiveWorkerThreadCount,
    const unsigned int RetiredWorkerThreadCount,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadStop())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ActiveWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolWorkerThreadStop, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadRetirementStart(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolWorkerThreadRetirementStart);
}

ULONG EventPipeWriteEventThreadPoolWorkerThreadRetirementStart(
    const unsigned int ActiveWorkerThreadCount,
    const unsigned int RetiredWorkerThreadCount,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadRetirementStart())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ActiveWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolWorkerThreadRetirementStart, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadRetirementStop(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolWorkerThreadRetirementStop);
}

ULONG EventPipeWriteEventThreadPoolWorkerThreadRetirementStop(
    const unsigned int ActiveWorkerThreadCount,
    const unsigned int RetiredWorkerThreadCount,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadRetirementStop())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ActiveWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolWorkerThreadRetirementStop, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentSample(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolWorkerThreadAdjustmentSample);
}

ULONG EventPipeWriteEventThreadPoolWorkerThreadAdjustmentSample(
    const double Throughput,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentSample())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Throughput, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolWorkerThreadAdjustmentSample, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentAdjustment(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolWorkerThreadAdjustmentAdjustment);
}

ULONG EventPipeWriteEventThreadPoolWorkerThreadAdjustmentAdjustment(
    const double AverageThroughput,
    const unsigned int NewWorkerThreadCount,
    const unsigned int Reason,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentAdjustment())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(AverageThroughput, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolWorkerThreadAdjustmentAdjustment, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentStats(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolWorkerThreadAdjustmentStats);
}

ULONG EventPipeWriteEventThreadPoolWorkerThreadAdjustmentStats(
    const double Duration,
    const double Throughput,
    const double ThreadWave,
    const double ThroughputWave,
    const double ThroughputErrorEstimate,
    const double AverageThroughputErrorEstimate,
    const double ThroughputRatio,
    const double Confidence,
    const double NewControlSetting,
    const unsigned short NewThreadWaveMagnitude,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentStats())
        return ERROR_SUCCESS;

    size_t size = 76;
    BYTE stackBuffer[76];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Duration, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Throughput, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ThreadWave, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ThroughputWave, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ThroughputErrorEstimate, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AverageThroughputErrorEstimate, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ThroughputRatio, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Confidence, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewControlSetting, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewThreadWaveMagnitude, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolWorkerThreadAdjustmentStats, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadWait(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolWorkerThreadWait);
}

ULONG EventPipeWriteEventThreadPoolWorkerThreadWait(
    const unsigned int ActiveWorkerThreadCount,
    const unsigned int RetiredWorkerThreadCount,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadWait())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ActiveWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolWorkerThreadWait, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledYieldProcessorMeasurement(void)
{
    return ep_event_is_enabled(EventPipeEventYieldProcessorMeasurement);
}

ULONG EventPipeWriteEventYieldProcessorMeasurement(
    const unsigned short ClrInstanceID,
    const double NsPerYield,
    const double EstablishedNsPerYield,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledYieldProcessorMeasurement())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NsPerYield, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(EstablishedNsPerYield, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventYieldProcessorMeasurement, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolMinMaxThreads(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolMinMaxThreads);
}

ULONG EventPipeWriteEventThreadPoolMinMaxThreads(
    const unsigned short MinWorkerThreads,
    const unsigned short MaxWorkerThreads,
    const unsigned short MinIOCompletionThreads,
    const unsigned short MaxIOCompletionThreads,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolMinMaxThreads())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(MinWorkerThreads, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MaxWorkerThreads, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MinIOCompletionThreads, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MaxIOCompletionThreads, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolMinMaxThreads, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkingThreadCount(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolWorkingThreadCount);
}

ULONG EventPipeWriteEventThreadPoolWorkingThreadCount(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkingThreadCount())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolWorkingThreadCount, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolEnqueue(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolEnqueue);
}

ULONG EventPipeWriteEventThreadPoolEnqueue(
    const void* WorkID,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolEnqueue())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(WorkID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolEnqueue, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolDequeue(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolDequeue);
}

ULONG EventPipeWriteEventThreadPoolDequeue(
    const void* WorkID,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolDequeue())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(WorkID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolDequeue, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolIOEnqueue(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolIOEnqueue);
}

ULONG EventPipeWriteEventThreadPoolIOEnqueue(
    const void* NativeOverlapped,
    const void* Overlapped,
    const BOOL MultiDequeues,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolIOEnqueue())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(NativeOverlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Overlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MultiDequeues, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolIOEnqueue, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolIODequeue(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolIODequeue);
}

ULONG EventPipeWriteEventThreadPoolIODequeue(
    const void* NativeOverlapped,
    const void* Overlapped,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolIODequeue())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(NativeOverlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Overlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolIODequeue, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolIOPack(void)
{
    return ep_event_is_enabled(EventPipeEventThreadPoolIOPack);
}

ULONG EventPipeWriteEventThreadPoolIOPack(
    const void* NativeOverlapped,
    const void* Overlapped,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolIOPack())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(NativeOverlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Overlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadPoolIOPack, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadCreating(void)
{
    return ep_event_is_enabled(EventPipeEventThreadCreating);
}

ULONG EventPipeWriteEventThreadCreating(
    const void* ID,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadCreating())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadCreating, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadRunning(void)
{
    return ep_event_is_enabled(EventPipeEventThreadRunning);
}

ULONG EventPipeWriteEventThreadRunning(
    const void* ID,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadRunning())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadRunning, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionThrown_V1(void)
{
    return ep_event_is_enabled(EventPipeEventExceptionThrown_V1);
}

ULONG EventPipeWriteEventExceptionThrown_V1(
    const WCHAR* ExceptionType,
    const WCHAR* ExceptionMessage,
    const void* ExceptionEIP,
    const unsigned int ExceptionHRESULT,
    const unsigned short ExceptionFlags,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionThrown_V1())
        return ERROR_SUCCESS;

    size_t size = 144;
    BYTE stackBuffer[144];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!ExceptionType) { ExceptionType = W("NULL"); }
    if (!ExceptionMessage) { ExceptionMessage = W("NULL"); }
    success &= WriteToBuffer(ExceptionType, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExceptionMessage, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExceptionEIP, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExceptionHRESULT, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExceptionFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventExceptionThrown_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionCatchStart(void)
{
    return ep_event_is_enabled(EventPipeEventExceptionCatchStart);
}

ULONG EventPipeWriteEventExceptionCatchStart(
    const uint64_t EntryEIP,
    const uint64_t MethodID,
    const WCHAR* MethodName,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionCatchStart())
        return ERROR_SUCCESS;

    size_t size = 82;
    BYTE stackBuffer[82];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!MethodName) { MethodName = W("NULL"); }
    success &= WriteToBuffer(EntryEIP, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventExceptionCatchStart, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionCatchStop(void)
{
    return ep_event_is_enabled(EventPipeEventExceptionCatchStop);
}

ULONG EventPipeWriteEventExceptionCatchStop(    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionCatchStop())
        return ERROR_SUCCESS;
    ep_write_event (EventPipeEventExceptionCatchStop, (uint8_t *) NULL, 0, (const uint8_t *)ActivityId, (const uint8_t *)RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionFinallyStart(void)
{
    return ep_event_is_enabled(EventPipeEventExceptionFinallyStart);
}

ULONG EventPipeWriteEventExceptionFinallyStart(
    const uint64_t EntryEIP,
    const uint64_t MethodID,
    const WCHAR* MethodName,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionFinallyStart())
        return ERROR_SUCCESS;

    size_t size = 82;
    BYTE stackBuffer[82];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!MethodName) { MethodName = W("NULL"); }
    success &= WriteToBuffer(EntryEIP, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventExceptionFinallyStart, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionFinallyStop(void)
{
    return ep_event_is_enabled(EventPipeEventExceptionFinallyStop);
}

ULONG EventPipeWriteEventExceptionFinallyStop(    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionFinallyStop())
        return ERROR_SUCCESS;
    ep_write_event (EventPipeEventExceptionFinallyStop, (uint8_t *) NULL, 0, (const uint8_t *)ActivityId, (const uint8_t *)RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionFilterStart(void)
{
    return ep_event_is_enabled(EventPipeEventExceptionFilterStart);
}

ULONG EventPipeWriteEventExceptionFilterStart(
    const uint64_t EntryEIP,
    const uint64_t MethodID,
    const WCHAR* MethodName,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionFilterStart())
        return ERROR_SUCCESS;

    size_t size = 82;
    BYTE stackBuffer[82];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!MethodName) { MethodName = W("NULL"); }
    success &= WriteToBuffer(EntryEIP, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventExceptionFilterStart, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionFilterStop(void)
{
    return ep_event_is_enabled(EventPipeEventExceptionFilterStop);
}

ULONG EventPipeWriteEventExceptionFilterStop(    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionFilterStop())
        return ERROR_SUCCESS;
    ep_write_event (EventPipeEventExceptionFilterStop, (uint8_t *) NULL, 0, (const uint8_t *)ActivityId, (const uint8_t *)RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionThrownStop(void)
{
    return ep_event_is_enabled(EventPipeEventExceptionThrownStop);
}

ULONG EventPipeWriteEventExceptionThrownStop(    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionThrownStop())
        return ERROR_SUCCESS;
    ep_write_event (EventPipeEventExceptionThrownStop, (uint8_t *) NULL, 0, (const uint8_t *)ActivityId, (const uint8_t *)RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledContention(void)
{
    return ep_event_is_enabled(EventPipeEventContention);
}

ULONG EventPipeWriteEventContention(    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledContention())
        return ERROR_SUCCESS;
    ep_write_event (EventPipeEventContention, (uint8_t *) NULL, 0, (const uint8_t *)ActivityId, (const uint8_t *)RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledContentionStart_V2(void)
{
    return ep_event_is_enabled(EventPipeEventContentionStart_V2);
}

ULONG EventPipeWriteEventContentionStart_V2(
    const unsigned char ContentionFlags,
    const unsigned short ClrInstanceID,
    const void* LockID,
    const void* AssociatedObjectID,
    const uint64_t LockOwnerThreadID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledContentionStart_V2())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ContentionFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LockID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssociatedObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LockOwnerThreadID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventContentionStart_V2, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledContentionStop_V1(void)
{
    return ep_event_is_enabled(EventPipeEventContentionStop_V1);
}

ULONG EventPipeWriteEventContentionStop_V1(
    const unsigned char ContentionFlags,
    const unsigned short ClrInstanceID,
    const double DurationNs,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledContentionStop_V1())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ContentionFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DurationNs, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventContentionStop_V1, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledContentionLockCreated(void)
{
    return ep_event_is_enabled(EventPipeEventContentionLockCreated);
}

ULONG EventPipeWriteEventContentionLockCreated(
    const void* LockID,
    const void* AssociatedObjectID,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledContentionLockCreated())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(LockID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssociatedObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventContentionLockCreated, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadCreated(void)
{
    return ep_event_is_enabled(EventPipeEventThreadCreated);
}

ULONG EventPipeWriteEventThreadCreated(
    const uint64_t ManagedThreadID,
    const uint64_t AppDomainID,
    const unsigned int Flags,
    const unsigned int ManagedThreadIndex,
    const unsigned int OSThreadID,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadCreated())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ManagedThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Flags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedThreadIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(OSThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventThreadCreated, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleLoad_V2(void)
{
    return ep_event_is_enabled(EventPipeEventModuleLoad_V2);
}

ULONG EventPipeWriteEventModuleLoad_V2(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    const WCHAR* ModuleILPath,
    const WCHAR* ModuleNativePath,
    const unsigned short ClrInstanceID,
    const GUID* ManagedPdbSignature,
    const unsigned int ManagedPdbAge,
    const WCHAR* ManagedPdbBuildPath,
    const GUID* NativePdbSignature,
    const unsigned int NativePdbAge,
    const WCHAR* NativePdbBuildPath,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleLoad_V2())
        return ERROR_SUCCESS;

    size_t size = 290;
    BYTE stackBuffer[290];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!ModuleILPath) { ModuleILPath = W("NULL"); }
    if (!ModuleNativePath) { ModuleNativePath = W("NULL"); }
    if (!ManagedPdbBuildPath) { ManagedPdbBuildPath = W("NULL"); }
    if (!NativePdbBuildPath) { NativePdbBuildPath = W("NULL"); }
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*ManagedPdbSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedPdbAge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedPdbBuildPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*NativePdbSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativePdbAge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativePdbBuildPath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventModuleLoad_V2, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIncreaseMemoryPressure(void)
{
    return ep_event_is_enabled(EventPipeEventIncreaseMemoryPressure);
}

ULONG EventPipeWriteEventIncreaseMemoryPressure(
    const uint64_t BytesAllocated,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledIncreaseMemoryPressure())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(BytesAllocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventIncreaseMemoryPressure, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDecreaseMemoryPressure(void)
{
    return ep_event_is_enabled(EventPipeEventDecreaseMemoryPressure);
}

ULONG EventPipeWriteEventDecreaseMemoryPressure(
    const uint64_t BytesFreed,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledDecreaseMemoryPressure())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(BytesFreed, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventDecreaseMemoryPressure, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCMarkWithType(void)
{
    return ep_event_is_enabled(EventPipeEventGCMarkWithType);
}

ULONG EventPipeWriteEventGCMarkWithType(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    const unsigned int Type,
    const uint64_t Bytes,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCMarkWithType())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Bytes, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCMarkWithType, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCJoin_V2(void)
{
    return ep_event_is_enabled(EventPipeEventGCJoin_V2);
}

ULONG EventPipeWriteEventGCJoin_V2(
    const unsigned int Heap,
    const unsigned int JoinTime,
    const unsigned int JoinType,
    const unsigned short ClrInstanceID,
    const unsigned int JoinID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCJoin_V2())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Heap, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JoinTime, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JoinType, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JoinID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCJoin_V2, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCPerHeapHistory_V3(void)
{
    return ep_event_is_enabled(EventPipeEventGCPerHeapHistory_V3);
}

ULONG EventPipeWriteEventGCPerHeapHistory_V3(
    const unsigned short ClrInstanceID,
    const void* FreeListAllocated,
    const void* FreeListRejected,
    const void* EndOfSegAllocated,
    const void* CondemnedAllocated,
    const void* PinnedAllocated,
    const void* PinnedAllocatedAdvance,
    const unsigned int RunningFreeListEfficiency,
    const unsigned int CondemnReasons0,
    const unsigned int CondemnReasons1,
    const unsigned int CompactMechanisms,
    const unsigned int ExpandMechanisms,
    const unsigned int HeapIndex,
    const void* ExtraGen0Commit,
    const unsigned int Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCPerHeapHistory_V3())
        return ERROR_SUCCESS;

    size_t size = 118;
    BYTE stackBuffer[118];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FreeListAllocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FreeListRejected, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(EndOfSegAllocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnedAllocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PinnedAllocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PinnedAllocatedAdvance, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RunningFreeListEfficiency, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnReasons0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnReasons1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CompactMechanisms, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExpandMechanisms, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(HeapIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExtraGen0Commit, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCPerHeapHistory_V3, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCGlobalHeapHistory_V4(void)
{
    return ep_event_is_enabled(EventPipeEventGCGlobalHeapHistory_V4);
}

ULONG EventPipeWriteEventGCGlobalHeapHistory_V4(
    const uint64_t FinalYoungestDesired,
    const signed int NumHeaps,
    const unsigned int CondemnedGeneration,
    const unsigned int Gen0ReductionCount,
    const unsigned int Reason,
    const unsigned int GlobalMechanisms,
    const unsigned short ClrInstanceID,
    const unsigned int PauseMode,
    const unsigned int MemoryPressure,
    const unsigned int CondemnReasons0,
    const unsigned int CondemnReasons1,
    const unsigned int Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCGlobalHeapHistory_V4())
        return ERROR_SUCCESS;

    size_t size = 82;
    BYTE stackBuffer[82];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(FinalYoungestDesired, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NumHeaps, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnedGeneration, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Gen0ReductionCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GlobalMechanisms, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PauseMode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MemoryPressure, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnReasons0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnReasons1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCGlobalHeapHistory_V4, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGenAwareBegin(void)
{
    return ep_event_is_enabled(EventPipeEventGenAwareBegin);
}

ULONG EventPipeWriteEventGenAwareBegin(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGenAwareBegin())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGenAwareBegin, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGenAwareEnd(void)
{
    return ep_event_is_enabled(EventPipeEventGenAwareEnd);
}

ULONG EventPipeWriteEventGenAwareEnd(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGenAwareEnd())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGenAwareEnd, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCLOHCompact(void)
{
    return ep_event_is_enabled(EventPipeEventGCLOHCompact);
}

ULONG EventPipeWriteEventGCLOHCompact(
    const unsigned short ClrInstanceID,
    const unsigned short Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCLOHCompact())
        return ERROR_SUCCESS;

    size_t size = 36;
    BYTE stackBuffer[36];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCLOHCompact, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFitBucketInfo(void)
{
    return ep_event_is_enabled(EventPipeEventGCFitBucketInfo);
}

ULONG EventPipeWriteEventGCFitBucketInfo(
    const unsigned short ClrInstanceID,
    const unsigned short BucketKind,
    const uint64_t TotalSize,
    const unsigned short Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFitBucketInfo())
        return ERROR_SUCCESS;

    size_t size = 46;
    BYTE stackBuffer[46];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BucketKind, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventGCFitBucketInfo, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExecutionCheckpoint(void)
{
    return ep_event_is_enabled(EventPipeEventExecutionCheckpoint);
}

ULONG EventPipeWriteEventExecutionCheckpoint(
    const unsigned short ClrInstanceID,
    const WCHAR* Name,
    const int64_t Timestamp,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledExecutionCheckpoint())
        return ERROR_SUCCESS;

    size_t size = 74;
    BYTE stackBuffer[74];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    if (!Name) { Name = W("NULL"); }
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Name, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Timestamp, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventExecutionCheckpoint, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledWaitHandleWaitStart(void)
{
    return ep_event_is_enabled(EventPipeEventWaitHandleWaitStart);
}

ULONG EventPipeWriteEventWaitHandleWaitStart(
    const unsigned char WaitSource,
    const void* AssociatedObjectID,
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledWaitHandleWaitStart())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(WaitSource, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssociatedObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventWaitHandleWaitStart, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledWaitHandleWaitStop(void)
{
    return ep_event_is_enabled(EventPipeEventWaitHandleWaitStop);
}

ULONG EventPipeWriteEventWaitHandleWaitStop(
    const unsigned short ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId)
{
    if (!EventPipeEventEnabledWaitHandleWaitStop())
        return ERROR_SUCCESS;

    size_t size = 32;
    BYTE stackBuffer[32];
    BYTE *buffer = stackBuffer;
    size_t offset = 0;
    bool fixedBuffer = true;
    bool success = true;

    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    ep_write_event (EventPipeEventWaitHandleWaitStop, (uint8_t *)buffer, (uint32_t)offset, reinterpret_cast<const uint8_t*>(ActivityId), reinterpret_cast<const uint8_t*>(RelatedActivityId));

    if (!fixedBuffer)
        delete[] buffer;


    return ERROR_SUCCESS;
}

void InitDotNETRuntime(void);

void InitDotNETRuntime(void)
{
    EventPipeProviderDotNETRuntime = create_provider(DotNETRuntimeName, reinterpret_cast<EventPipeCallback>(EventPipeEtwCallbackDotNETRuntime));
    EventPipeEventGCStart_V2 = ep_provider_add_event(EventPipeProviderDotNETRuntime,1,1,2,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCEnd_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,2,1,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCRestartEEEnd_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,3,1,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCHeapStats_V2 = ep_provider_add_event(EventPipeProviderDotNETRuntime,4,1,2,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCCreateSegment_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,5,1,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCFreeSegment_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,6,1,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCRestartEEBegin_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,7,1,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCSuspendEEEnd_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,8,1,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCSuspendEEBegin_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,9,1,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCAllocationTick_V4 = ep_provider_add_event(EventPipeProviderDotNETRuntime,10,1,4,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventGCCreateConcurrentThread_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,11,65537,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCTerminateConcurrentThread_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,12,65537,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCFinalizersEnd_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,13,1,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCFinalizersBegin_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,14,1,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventBulkType = ep_provider_add_event(EventPipeProviderDotNETRuntime,15,524288,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCBulkRootEdge = ep_provider_add_event(EventPipeProviderDotNETRuntime,16,1048576,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCBulkRootConditionalWeakTableElementEdge = ep_provider_add_event(EventPipeProviderDotNETRuntime,17,1048576,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCBulkNode = ep_provider_add_event(EventPipeProviderDotNETRuntime,18,1048576,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCBulkEdge = ep_provider_add_event(EventPipeProviderDotNETRuntime,19,1048576,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCSampledObjectAllocationHigh = ep_provider_add_event(EventPipeProviderDotNETRuntime,20,2097152,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventGCBulkSurvivingObjectRanges = ep_provider_add_event(EventPipeProviderDotNETRuntime,21,4194304,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCBulkMovedObjectRanges = ep_provider_add_event(EventPipeProviderDotNETRuntime,22,4194304,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCGenerationRange = ep_provider_add_event(EventPipeProviderDotNETRuntime,23,4194304,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCMarkStackRoots = ep_provider_add_event(EventPipeProviderDotNETRuntime,25,1,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCMarkFinalizeQueueRoots = ep_provider_add_event(EventPipeProviderDotNETRuntime,26,1,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCMarkHandles = ep_provider_add_event(EventPipeProviderDotNETRuntime,27,1,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCMarkOlderGenerationRoots = ep_provider_add_event(EventPipeProviderDotNETRuntime,28,1,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventFinalizeObject = ep_provider_add_event(EventPipeProviderDotNETRuntime,29,1,0,EP_EVENT_LEVEL_VERBOSE,false,NULL,0);
    EventPipeEventSetGCHandle = ep_provider_add_event(EventPipeProviderDotNETRuntime,30,2,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventDestroyGCHandle = ep_provider_add_event(EventPipeProviderDotNETRuntime,31,2,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventGCSampledObjectAllocationLow = ep_provider_add_event(EventPipeProviderDotNETRuntime,32,33554432,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventPinObjectAtGCTime = ep_provider_add_event(EventPipeProviderDotNETRuntime,33,1,0,EP_EVENT_LEVEL_VERBOSE,false,NULL,0);
    EventPipeEventGCTriggered = ep_provider_add_event(EventPipeProviderDotNETRuntime,35,1,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventGCBulkRootCCW = ep_provider_add_event(EventPipeProviderDotNETRuntime,36,1048576,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCBulkRCW = ep_provider_add_event(EventPipeProviderDotNETRuntime,37,1048576,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCBulkRootStaticVar = ep_provider_add_event(EventPipeProviderDotNETRuntime,38,1048576,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCDynamicEvent = ep_provider_add_event(EventPipeProviderDotNETRuntime,39,66060291,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventThreadpoolSuspensionSuspendThread = ep_provider_add_event(EventPipeProviderDotNETRuntime,48,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventThreadpoolSuspensionResumeThread = ep_provider_add_event(EventPipeProviderDotNETRuntime,49,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventThreadPoolWorkerThreadStart = ep_provider_add_event(EventPipeProviderDotNETRuntime,50,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventThreadPoolWorkerThreadStop = ep_provider_add_event(EventPipeProviderDotNETRuntime,51,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventThreadPoolWorkerThreadRetirementStart = ep_provider_add_event(EventPipeProviderDotNETRuntime,52,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventThreadPoolWorkerThreadRetirementStop = ep_provider_add_event(EventPipeProviderDotNETRuntime,53,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventThreadPoolWorkerThreadAdjustmentSample = ep_provider_add_event(EventPipeProviderDotNETRuntime,54,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventThreadPoolWorkerThreadAdjustmentAdjustment = ep_provider_add_event(EventPipeProviderDotNETRuntime,55,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventThreadPoolWorkerThreadAdjustmentStats = ep_provider_add_event(EventPipeProviderDotNETRuntime,56,65536,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventThreadPoolWorkerThreadWait = ep_provider_add_event(EventPipeProviderDotNETRuntime,57,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventYieldProcessorMeasurement = ep_provider_add_event(EventPipeProviderDotNETRuntime,58,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventThreadPoolMinMaxThreads = ep_provider_add_event(EventPipeProviderDotNETRuntime,59,65536,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventThreadPoolWorkingThreadCount = ep_provider_add_event(EventPipeProviderDotNETRuntime,60,65536,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventThreadPoolEnqueue = ep_provider_add_event(EventPipeProviderDotNETRuntime,61,2147549184,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventThreadPoolDequeue = ep_provider_add_event(EventPipeProviderDotNETRuntime,62,2147549184,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventThreadPoolIOEnqueue = ep_provider_add_event(EventPipeProviderDotNETRuntime,63,2147549184,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventThreadPoolIODequeue = ep_provider_add_event(EventPipeProviderDotNETRuntime,64,2147549184,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventThreadPoolIOPack = ep_provider_add_event(EventPipeProviderDotNETRuntime,65,65536,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventThreadCreating = ep_provider_add_event(EventPipeProviderDotNETRuntime,70,2147549184,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventThreadRunning = ep_provider_add_event(EventPipeProviderDotNETRuntime,71,2147549184,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventExceptionThrown_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,80,8589967360,1,EP_EVENT_LEVEL_ERROR,true,NULL,0);
    EventPipeEventExceptionCatchStart = ep_provider_add_event(EventPipeProviderDotNETRuntime,250,32768,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventExceptionCatchStop = ep_provider_add_event(EventPipeProviderDotNETRuntime,251,32768,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventExceptionFinallyStart = ep_provider_add_event(EventPipeProviderDotNETRuntime,252,32768,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventExceptionFinallyStop = ep_provider_add_event(EventPipeProviderDotNETRuntime,253,32768,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventExceptionFilterStart = ep_provider_add_event(EventPipeProviderDotNETRuntime,254,32768,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventExceptionFilterStop = ep_provider_add_event(EventPipeProviderDotNETRuntime,255,32768,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventExceptionThrownStop = ep_provider_add_event(EventPipeProviderDotNETRuntime,256,32768,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventContention = ep_provider_add_event(EventPipeProviderDotNETRuntime,81,0,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventContentionStart_V2 = ep_provider_add_event(EventPipeProviderDotNETRuntime,81,16384,2,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventContentionStop_V1 = ep_provider_add_event(EventPipeProviderDotNETRuntime,91,16384,1,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventContentionLockCreated = ep_provider_add_event(EventPipeProviderDotNETRuntime,90,16384,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventThreadCreated = ep_provider_add_event(EventPipeProviderDotNETRuntime,85,67584,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventModuleLoad_V2 = ep_provider_add_event(EventPipeProviderDotNETRuntime,152,536870920,2,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventIncreaseMemoryPressure = ep_provider_add_event(EventPipeProviderDotNETRuntime,200,1,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventDecreaseMemoryPressure = ep_provider_add_event(EventPipeProviderDotNETRuntime,201,1,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventGCMarkWithType = ep_provider_add_event(EventPipeProviderDotNETRuntime,202,1,0,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCJoin_V2 = ep_provider_add_event(EventPipeProviderDotNETRuntime,203,1,2,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventGCPerHeapHistory_V3 = ep_provider_add_event(EventPipeProviderDotNETRuntime,204,1,3,EP_EVENT_LEVEL_INFORMATIONAL,false,NULL,0);
    EventPipeEventGCGlobalHeapHistory_V4 = ep_provider_add_event(EventPipeProviderDotNETRuntime,205,1,4,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventGenAwareBegin = ep_provider_add_event(EventPipeProviderDotNETRuntime,206,1048576,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventGenAwareEnd = ep_provider_add_event(EventPipeProviderDotNETRuntime,207,1048576,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventGCLOHCompact = ep_provider_add_event(EventPipeProviderDotNETRuntime,208,1,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventGCFitBucketInfo = ep_provider_add_event(EventPipeProviderDotNETRuntime,209,1,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventExecutionCheckpoint = ep_provider_add_event(EventPipeProviderDotNETRuntime,300,536870912,0,EP_EVENT_LEVEL_INFORMATIONAL,true,NULL,0);
    EventPipeEventWaitHandleWaitStart = ep_provider_add_event(EventPipeProviderDotNETRuntime,301,4398046511104,0,EP_EVENT_LEVEL_VERBOSE,true,NULL,0);
    EventPipeEventWaitHandleWaitStop = ep_provider_add_event(EventPipeProviderDotNETRuntime,302,4398046511104,0,EP_EVENT_LEVEL_VERBOSE,false,NULL,0);
}

bool DotNETRuntimeProvider_IsEnabled(unsigned char level, unsigned long long keyword)
{
    if (!ep_enabled())
        return false;

    EVENTPIPE_TRACE_CONTEXT& context = MICROSOFT_WINDOWS_DOTNETRUNTIME_PROVIDER_DOTNET_Context.EventPipeProvider;
    if (!context.IsEnabled)
        return false;

    if (level > context.Level)
        return false;

    return (keyword == (ULONGLONG)0) || (keyword & context.EnabledKeywordsBitmask) != 0;
}
